Subject: ElementBrowser::getThisScript is not public
Description

In \TYPO3\CMS\Recordlist\Browser\ElementBrowser the method getThisScript is not public but you need it in your hooks fot the
LinkBrowser (to generate a valid url). You can use the public property but as the core implementation is like:

$menuDef['page']['addParams'] = 'onclick="jumpToUrl(' . GeneralUtility::quoteJSvalue($this->getThisScript() . 'act=page') . ');return
false;"';

It should be possible to use this method also from your hook

So please simple change accessibility for getThisScript to public.

Otherwise you have to do this in every single hook:
$script = strpos($this->parentObject->thisScript, '?') === FALSE ? $this->parentObject->thisScript . '?' :
$this->parentObject->thisScript . '&';
$menuDefinition['KEY']['addParams'] = 'onclick="jumpToUrl(' . GeneralUtility::quoteJSvalue($script . 'act=KEY') . ');return false;"';

Additionally i have to say:
The common way before to generate the tab link was
$menuDefinition['KEY']['addParams'] = 'onclick="jumpToUrl(\'' . htmlspecialchars(('?act=KEY&mode=' . $this->parentObject->mode .
'&bparams=' . $this->parentObject->bparams)) . '\');return false;"';

This is not compatible with TYPO3 6.2 anymore because of this new moduleToken, so it might be better to rethink that behaviour for
the whole wizard. Otherwise many extension would be broken in that context.

Associated revisions
Revision b2756fe7 - 2014-03-17 20:37 - Georg Ringer

[TASK] Declare getThisScript() in ElementBrowser as public

To make work in hooks easier, the method should be public

Resolves: #56721
Releases: 6.2
Change-Id: Ib0a0f17d5f9384a04a125ef08a079f4c272eddae
Reviewed-on: https://review.typo3.org/28337
Reviewed-by: Alexander Stehlik
Tested-by: Alexander Stehlik
Reviewed-by: Markus Klein
Tested-by: Markus Klein

Revision 2144d4c6 - 2014-03-23 11:41 - Helmut Hummel

[BUGFIX] Ensure backwards compatibility in element browser

Hooks that used the element browser used the JavaScript
function jumpToUrl with relative URLs.

After refactoring the element browser, it was necessary
to compute the absolute URL.

To stay backwards compatible we catch this case
in JavaScript and rewrite the URL according
to the new requirements.

By doing so, we can simplify our code again.

The method getThisScript might still be needed in
Hooks for other purposes, so we make it public.

Resolves: #56721
Releases: 6.2
Change-Id: Ieed6d037b428c5c15d18905341ff46dece1d67a7
Reviewed-on: https://review.typo3.org/28618
Reviewed-by: Ernesto Baschny
Reviewed-by: Markus Klein
Tested-by: Markus Klein
Reviewed-by: Stefan Neufeind
Reviewed-by: Wouter Wolters
Reviewed-by: Helmut Hummel
Tested-by: Helmut Hummel

History
#1 - 2014-03-13 11:19 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28337

#2 - 2014-03-15 22:41 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28337

#3 - 2014-03-16 13:59 - Ernesto Baschny
- Subject changed from Getter is not public to ElementBrowser::getThisScript is not public

#4 - 2014-03-17 20:49 - Gerrit Code Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28479

#5 - 2014-03-17 20:51 - Markus Klein

First patch was reverted in https://review.typo3.org/28478.
Repushed under https://review.typo3.org/28479

#6 - 2014-03-17 21:30 - Georg Ringer
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:b2756fe7826d62fdc8442c887010890c268eabd8.

#7 - 2014-03-17 22:44 - Markus Klein
- Status changed from Resolved to Under Review

#8 - 2014-03-21 19:35 - Gerrit Code Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28618

#9 - 2014-03-21 22:04 - Helmut Hummel
- Parent task set to #55516

#10 - 2014-03-21 22:04 - Helmut Hummel
- Estimated time changed from 0.10 to 1.00

#11 - 2014-03-23 12:30 - Helmut Hummel
- Status changed from Under Review to Resolved

Applied in changeset commit:2144d4c6e0f997f824e9dc41eb3eafb2b48a180d.
